SD_BUS_IS_OPEN(3)

NAME
sd_bus_is_open, sd_bus_is_ready - Check whether the bus connection is open or ready

SYNOPSIS

#include <systemd/sd-bus.h>

int sd_bus_is_open(sd_bus *bus);

int sd_bus_is_ready(sd_bus *bus);

DESCRIPTION

sd_bus_is_open() checks whether the specified bus connection is open, i.e. in the process of being established, already established or in the process of being torn down. It returns zero when the connection has not been started yet (i.e. sd_bus_start(3) or some equivalent call has not been invoked yet), or is fully terminated again (for example after sd_bus_close(3)), it returns positive otherwise.

sd_bus_is_ready() checks whether the specified connection is fully established, i.e. completed the connection and authentication phases of the protocol and received the Hello() method call response, and is not in the process of being torn down again. It returns zero outside of this state, and positive otherwise. Effectively, this function returns positive while regular messages can be sent or received on the connection.

The bus argument may be NULL, zero is also returned in that case.

To be notified when the connection is fully established, use sd_bus_set_connected_signal(3) and install a match for the Connected() signal on the "org.freedesktop.DBus.Local" interface. To be notified when the connection is torn down again, install a match for the Disconnected() signal on the "org.freedesktop.DBus.Local" interface.

RETURN VALUE

Those functions return 0 if the bus is not in the given state, and a positive integer when it is. On failure, a negative errno-style error code is returned.

  Errors

Returned errors may indicate the following problems:

-ECHILD
    The bus connection has been created in a different process, library or module instance.

NOTES

Functions described here are available as a shared library, which can be compiled against and linked to with the libsystemd pkg-config(1) file.

The code described here uses getenv(3), which is declared to be not multi-thread-safe. This means that the code calling the functions described here must not call setenv(3) from a parallel thread. It is recommended to only do calls to setenv() from an early phase of the program when no other threads have been started.

SEE ALSO

systemd(1), sd-bus(3), sd_bus_start(3), sd_bus_close(3), sd_bus_set_connected_signal(3)